// cc2menuDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cc2menu.h"
#include "cc2menuDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static OPENFILENAME ofn;										/* Structure used by the "Open File" dialogbox */
static BROWSEINFO bi;
static TCHAR szInputFileName[MAX_PATH];							/* Space for the filename */
static TCHAR szOutputFolderName[MAX_PATH];
static int FolderImage;
static TCHAR szAppName[] = "CC2 Menu Convertor";
static HICON hIcon;												/* Dialog icon handle */

void makeupper(char *string)
{
	unsigned int i;
	for(i = 0;i < strlen(string); i++)
		string[i] = toupper(string[i]);
}

/////////////////////////////////////////////////////////////////////////////
// CCc2menuDlg dialog

CCc2menuDlg::CCc2menuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCc2menuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCc2menuDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(CC_ICON);
}

void CCc2menuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCc2menuDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCc2menuDlg, CDialog)
	//{{AFX_MSG_MAP(CCc2menuDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SelectInputMenu, OnSelectInputMenu)
	ON_BN_CLICKED(IDC_SelectOutputMenu, OnSelectOutputMenu)
	ON_BN_CLICKED(IDC_Convert, OnConvert)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCc2menuDlg message handlers

BOOL CCc2menuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	/* Filter for File dialogbox */
	static TCHAR szFilter[] = TEXT("Text Files (*.TXT)\0*.txt\0")  \
								TEXT("All Files (*.*)\0*.*\0\0");

	/* Fill File Open dialogbox structure */
	ofn.lStructSize       = sizeof(OPENFILENAME);	/* Struct size */
	ofn.hwndOwner         = this->m_hWnd;			/* Owner window */
	ofn.hInstance         = NULL;
	ofn.lpstrFilter       = szFilter;				/* Filter */
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 0;						/* Selected filter index */
	ofn.nMaxFile          = MAX_PATH;				/* Max. characters for filename */
	ofn.nMaxFileTitle     = MAX_PATH;
	ofn.lpstrInitialDir   = NULL;					/* Initial directory */
	ofn.lpstrTitle        = NULL;					/* Title of dialogbox */
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = TEXT("txt");			/* Default extension */
	ofn.lCustData         = 0L;
	ofn.lpfnHook		= NULL;
	ofn.lpTemplateName	= NULL;
	ofn.lpstrFile		= szInputFileName;			/* Filename buffer */
	ofn.lpstrFileTitle	= NULL;
	ofn.Flags			= 0 ;

	/* Fill Folder Browse dialogbox structure */
	bi.hwndOwner		= this->m_hWnd;
	bi.pszDisplayName	= szOutputFolderName;
	bi.lpszTitle		= NULL;
	bi.ulFlags			= BIF_RETURNONLYFSDIRS;
	bi.lpfn				= NULL;
	bi.lParam			= NULL;
	bi.iImage			= FolderImage;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCc2menuDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCc2menuDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCc2menuDlg::OnSelectInputMenu() 
{
	// TODO: Add your control notification handler code here
	if (GetOpenFileName(&ofn)) SetDlgItemText(IDC_INPUTFILENAME, szInputFileName);
}

void CCc2menuDlg::OnSelectOutputMenu() 
{
	LPITEMIDLIST FolderID;
	LPMALLOC pMalloc;
	if (SUCCEEDED(SHGetMalloc(&pMalloc)))
	{
		FolderID = SHBrowseForFolder(&bi);
		if(FolderID)
		{
			SHGetPathFromIDList(FolderID,szOutputFolderName);
			SetDlgItemText(IDC_OUTPUTDIRNAME, szOutputFolderName);
			pMalloc->Free(FolderID);
		}
		pMalloc->Release();
	}
}

void CCc2menuDlg::OnConvert() 
{
	// TODO: Add your control notification handler code here
	FILE *infile, *outfile;
	TCHAR ErrorMessage[600];
	GetDlgItemText(IDC_INPUTFILENAME, szInputFileName, MAX_PATH);
	BOOL Failure = FALSE;
	if(_tcslen(szInputFileName) != 0)
	{
		if((infile = fopen((const char *)szInputFileName,"r")) == NULL)
		{		
			MessageBox("Error!  Unable to open input file.", szAppName, MB_ICONEXCLAMATION | MB_OK);
			return;
		}
	}
	else
	{
		return;
	}
	TCHAR szOutputFileName[MAX_PATH+8];
	TCHAR szOutputDrive[_MAX_DRIVE];
	TCHAR szOutputDir[_MAX_DIR];
	TCHAR szOutputName[_MAX_FNAME];
	TCHAR szOutputExt[_MAX_EXT];
	_tsplitpath(szInputFileName, szOutputDrive, szOutputDir, szOutputName, szOutputExt);
	_tcscpy(szOutputExt,"CC2");
	_tmakepath(szOutputFileName, szOutputDrive, szOutputDir, szOutputName, szOutputExt);
	if((outfile = fopen((const char *)szOutputFileName,"w")) == NULL)
	{
		_stprintf(ErrorMessage, "Error!  Unable to create %s file.", szOutputFileName);
		MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
		return;
	}


	char seps[] = "\t\r\n";
	char *token;
	char line[500], linecopy[500];
	char gamename[41],romname[9],bankswitch[9],startname[9];


	int count = 0;
	int linecount = 0;
	while(fgets(line, 500, infile) != NULL)
	{
		strcpy(linecopy,line);	//Copy line for error display purposes.  strtok will chop line up.
		linecount++;
		if((token = strtok(line, seps)) == NULL)
		{
			sprintf(ErrorMessage,"Error:  Line %d is invalid.\nThe line is shown below:\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		if(strlen(token) > 40)
		{
			sprintf(ErrorMessage,"Error:  Menu name entry on line %d is longer than 40 characters.\nThe line is shown below:\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		strcpy(gamename,token);
		if(strlen(gamename) < 40)
		{
			for(count = strlen(gamename);count < 40;count++)
				gamename[count] = ' ';
			gamename[count] = 0;
		}


		if((token = strtok(NULL, seps)) == NULL)
		{
			sprintf(ErrorMessage,"Error:  Too few entries on line %d.\nThe line is shown below:\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		if(strlen(token) > 8)
		{
			sprintf(ErrorMessage,"Error:  Game filename entry on line %d is longer than 8 characters.\nThe line is shown below:\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, line/*szAppName*/, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		strcpy(romname,token);
		if(strlen(romname) < 8)
		{
			for(count = strlen(romname);count < 8;count++)
				romname[count] = ' ';
			romname[count] = 0;
		}
		makeupper(romname);



		if((token = strtok(NULL, seps)) == NULL)
		{
			sprintf(ErrorMessage,"Error:  Too few entries on line %d.\nThe line is shown below.\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		if(strlen(token) > 8)
		{
			sprintf(ErrorMessage,"Error:  Bankswitching filename entry on line %d is longer than 8 characters.\nThe line is shown below:\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		strcpy(bankswitch,token);
		if(strlen(bankswitch) < 8)
		{
			for(count = strlen(bankswitch);count < 8;count++)
				bankswitch[count] = ' ';
			bankswitch[count] = 0;
		}
		makeupper(bankswitch);

		if((token = strtok(NULL, seps)) == NULL)
		{
			sprintf(ErrorMessage,"Error:  Too few entries on line %d.\nThe line is shown below.\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		if(strlen(token) > 8)
		{
			sprintf(ErrorMessage,"Error:  Startup filename entry on line %d is longer than 8 characters.\nThe line is shown below:\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		strcpy(startname,token);
		if(strlen(startname) < 8)
		{
			for(count = strlen(startname);count < 8;count++)
				startname[count] = ' ';
			startname[count] = 0;
		}
		makeupper(startname);

		if((token = strtok(NULL, seps)) != NULL)
		{
			sprintf(ErrorMessage,"Error:  Too many entries on line %d.\nThe line is shown below.\n\n%s",linecount,linecopy);
			MessageBox(ErrorMessage, szAppName, MB_ICONEXCLAMATION | MB_OK);
			Failure = TRUE;
			break;
		}
		

		fprintf(outfile,"%s%s%s%s",gamename,romname,bankswitch,startname);
	}

	if(Failure == FALSE)
	{
		_stprintf(ErrorMessage, "%s successfully created!", szOutputFileName);
		MessageBox(ErrorMessage,szAppName,MB_OK);
	}
	fclose(infile);
	fclose(outfile);
	if(Failure == TRUE)
		_tremove(szOutputFileName);
}
