/*This program converts Xilinx FPGA Hex files to Binary files suitable for loading
into an FPGA using a microcontroller.*/
//#include <stdio.h>
#include "stdafx.h"
#include <iostream>
#include <string.h>
using namespace std;

static TCHAR szAppName [] = TEXT("CC2 Menu");

void makeupper(char *string)
{
	int i;
	for(i = 0;i < strlen(string); i++)
		string[i] = toupper(string[i]);
}
void convert_menu(char *InputFilename, char *OutputFileFolder)
{
	FILE *infile, *outfile; 
	if((infile = fopen((const char *)InputFilename,"r")) == NULL)
	{
		CString ErrorMsg = "Hi";
		MessageBox(ErrorMsg, szAppName, MB_ICONEXCLAMATION | MB_OK);
		//cerr << "File " << argv[1] << " not found." << endl;
		//return 1;
	}
	if((outfile = fopen((const char *)argv[2],"w")) == NULL)
	{
		cerr << "Unable to created file " << argv[2] << "." << endl;
		return 1;
	}
	char seps[] = "\t\r\n";
	char *token;
	char line[500];
	char gamename[100],romname[100],instname[100],bankswitch[100],startname[100];
	int count = 0;
	//fprintf(outfile,"0         1         2         3 0       0       0       0\n");
	//while (fscanf(infile,"%s\t%s\t%s\t%s\t%s",&gamename,&romname,&instname,&bankswitch,&startname) != EOF)
	while(fgets(line, 500, infile) != NULL)
	{
		cout << line;
		token = strtok(line, seps);
		strcpy(gamename,token);
		if((strlen(gamename) > 32) | (strlen(gamename) == 0))
		{
			cerr << "Error:  Game name " << gamename << "is more then 32 bytes long.";
			return 1;
		}
		if(strlen(gamename) < 32)
		{
			for(count = strlen(gamename);count < 32;count++)
				gamename[count] = ' ';
			gamename[count] = 0;
		}


		token = strtok(NULL, seps);
		strcpy(romname,token);
		if(strlen(romname) > 8)
		{
			cerr << "Error:  ROM name " << romname << "is more then 8 bytes long.";
			return 1;
		}
		if(strlen(romname) < 8)
		{
			for(count = strlen(romname);count < 8;count++)
				romname[count] = ' ';
			romname[count] = 0;
		}
		makeupper(romname);


		token = strtok(NULL, seps);
		strcpy(instname,token);
		if(strlen(instname) > 8)
		{
			cerr << "Error:  Instruction name " << instname << "is more then 8 bytes long.";
			return 1;
		}
		if(strlen(instname) < 8)
		{
			for(count = strlen(instname);count < 8;count++)
				instname[count] = ' ';
			instname[count] = 0;
		}
		makeupper(instname);


		token = strtok(NULL, seps);
		strcpy(bankswitch,token);
		if(strlen(bankswitch) > 8)
		{
			cerr << "Error:  Bankswitch name " << bankswitch << "is more then 8 bytes long.";
			return 1;
		}
		if(strlen(bankswitch) < 8)
		{
			for(count = strlen(bankswitch);count < 8;count++)
				bankswitch[count] = ' ';
			bankswitch[count] = 0;
		}
		makeupper(bankswitch);

		token = strtok(NULL, seps);
		strcpy(startname,token);
		if(strlen(startname) > 8)
		{
			cerr << "Error:  Startup name " << startname << "is more then 8 bytes long.";
			return 1;
		}
		if(strlen(startname) < 8)
		{
			for(count = strlen(startname);count < 8;count++)
				startname[count] = ' ';
			startname[count] = 0;
		}
		makeupper(startname);

		fprintf(outfile,"%s%s%s%s%s",gamename,romname,instname,bankswitch,startname);
	}
	fclose(infile);
	fclose(outfile);
	return 0;
}