#ifndef ROMDB_H
#define ROMDB_H

#define MAX_GAME_NAME_LEN	40
#define MAX_FILE_NAME_LEN	8

struct romdb;

struct romentry
{
	unsigned long	CRC;
	char		Name[MAX_GAME_NAME_LEN+1];
	char		RomName[MAX_FILE_NAME_LEN+1];
	char		Bankswitch[MAX_FILE_NAME_LEN+1];
	char		Startup[MAX_FILE_NAME_LEN+1];
};

typedef int romdb_walk_fn(struct romentry* ent);

extern struct romdb* romdb_load(FILE* file);
extern int romdb_size(const struct romdb* db);
extern int romdb_walk(struct romdb* db, romdb_walk_fn* fn);
extern struct romentry* romdb_find_crc(struct romdb* db, unsigned long crc, unsigned long *count);
extern void romdb_free(struct romdb* db);

#endif /* ROMDB_H */
